<template>
  <v-list-item
    icon
    dense
    :disabled="!analysis"
    @click="upload()"
  >
    <v-list-item-icon>
      <v-icon :class="{ 'upload-transition': transition }" class="upload-icon">
        {{
          completed ? 'mdi-check' : 'mdi-cloud-upload'
        }}
      </v-icon>
    </v-list-item-icon>
    <v-list-item-content>
      <v-list-item-title>
        {{ $t('button.upload') }}
      </v-list-item-title>
    </v-list-item-content>
  </v-list-item>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, PropSync,
} from 'vue-property-decorator';
import type { Client } from '@/client';
import { showUpload } from '@/components/dialogs';
import type { Analysis } from '@/data';

@Component
export default class UploadButton extends Vue {
  @Prop()
  client!: Client;

  @Prop()
  piecePath!: string;

  @Prop()
  analysis!: Analysis | null;

  @PropSync('clean')
  isClean!: boolean;

  completed = false;

  transition = false;

  async upload() {
    if (!this.piecePath || !this.analysis) return;
    // Try to upload
    const analysisId = await showUpload(
      this.client,
      this.piecePath,
      this.analysis,
    );

    // If upload unsuccessful, don't route to anything
    // TODO: warn user
    if (!analysisId) return;

    this.triggerCompletedTransition();
    setTimeout(() => {
      this.completed = true;
    }, 500);
    setTimeout(() => {
      this.triggerCompletedTransition();
      setTimeout(() => {
        this.completed = false;
      }, 500);
    }, 5000);

    // Update route
    this.isClean = true;
    this.$router.replace({ query: { analysisId } });
    this.emitReloadAnalyses();
  }

  triggerCompletedTransition() {
    this.transition = true;
    setTimeout(() => {
      this.transition = false;
    }, 500);
  }

  emitReloadAnalyses() {
    this.$emit('reload-analyses');
  }
}
</script>

<style lang="scss" scoped>
.upload {
  &-icon {
    opacity: 1;
    transition: opacity 1s;
  }
  &-transition {
    opacity: 0;
    transition: opacity 1s;
  }
}
</style>
